---
subtitle: Dome Framework
---

**Dome** allows you to build native, desktop applications using
[React](https://reactjs.org) javascript technology. It is build upon the
[Electron](http://electron.atom.io) framework, featuring a full-featured Chromium
engine which renders the graphical user interface to the user.

The **Dome** framework provides you with the following facilities:
- all-in-one pre-configured rich development environment
- live-editing of your application code
- a collection of ready-to-use, well designed, scalable components
- easy integration with any other React components from your own
- binary distribution for all supported platform (Windows, Linux and MacOS)

## To Start With

- [Quick Start](quickstart.md)
- [Live Editing](hotreload.md)
- [Application Design](application.md)
- [Application Development](development.md)
- [Styling Components](styling.md)

## References

- [Custom Hooks](hooks.md)
- [Icons Gallery](icons.md)
- [Glossary](glossary.md)
